#ifndef DATENSATZ_H
#define DATENSATZ_H

#include <QString>
#include <QHash>

class Datensatz {
  public:
    Datensatz(const QString &nachname, const QString &vorname)
    {
      m_vorname = vorname;
      m_nachname = nachname;
    }

    QString vorname() const { return m_vorname; }
    QString nachname() const { return m_nachname; }

  private:
    QString m_vorname;
    QString m_nachname;
};
inline bool operator<(const Datensatz &e1, const Datensatz &e2)
{
  if ( e1.nachname() != e2.nachname() )
    return e1.nachname() < e2.nachname();
  return e1.vorname() < e2.vorname();
}
inline bool operator==(const Datensatz &e1, const Datensatz &e2)
{
   return (e1.nachname() == e2.nachname())
       && (e1.vorname() == e2.vorname());
}

inline uint qHash(const Datensatz& key)
{
   return qHash(key.nachname()) ^ qHash(key.vorname());
}

#endif // DATENSATZ_H
