#include "clicksplitter.h"
#include <QtGui>

ClickSplitterHandle::ClickSplitterHandle(Qt::Orientation o, 
  QSplitter *parent) :QSplitterHandle(o, parent)
{
  lastUncollapsedSize = 0;
}

void ClickSplitterHandle::mouseDoubleClickEvent(QMouseEvent *e)
{
  QSplitter *s = splitter();
  Qt::Orientation o = s->orientation();
  int pos = s->indexOf(this);

  QWidget *w = s->widget(pos);

  if (lastUncollapsedSize == 0)
    if (o == Qt::Horizontal)
      lastUncollapsedSize = w->sizeHint().width();
    else
      lastUncollapsedSize = w->sizeHint().height();

  int currSize = s->sizes().value(pos-1);

  if (currSize == 0)
    moveSplitter(lastUncollapsedSize);
  else {
    lastUncollapsedSize = currSize;
    moveSplitter(0);
  }

}

