#include <QtGui>
#include "configwidget.h"

ConfigWidget::ConfigWidget(QWidget *parent)
 : QWidget(parent)
{
  QHBoxLayout *lay = new QHBoxLayout(this);

  contentsWidget = new QListWidget;
  widgetStack = new QStackedWidget;

  lay->addWidget(contentsWidget);
  lay->addWidget(widgetStack);

  contentsWidget->setMaximumWidth(180);

  connect(contentsWidget, SIGNAL(currentRowChanged(int)), 
          widgetStack, SLOT(setCurrentIndex(int)));

}

void ConfigWidget::addPage(const QString& title, const QIcon& icon, 
                           QWidget *page)
{
  QListWidgetItem *item = new QListWidgetItem;
  item->setText(title);
  item->setIcon(icon);
  contentsWidget->addItem(item);
  widgetStack->addWidget(page);
}

